(*
 * SNU 4190.310 Programming Languages (Fall 2008)
 *
 * SM5
 *)

open HW 

fun main () =
    let
      val ptree = ref false
      val src = ref ""

      val _ =
        Arg.parse
          [("-ptree", Arg.Set ptree, "display parse tree")]
          (fn x => src := x)
          ("Usage: " ^ (Filename.basename Sys.argv.[0]) ^ " [-ptree] [file]")
    in
      let
        val lexbuf =
          Lexing.from_channel (if !src = "" then stdin else open_in !src)
        val pgm = Parser.program Lexer.start lexbuf
      in
        if !ptree then KParseTreePrinter.print pgm
        else ignore (Sm5.run(trans pgm))
      end
    end

val _ = main ()
